                    #define MAGIC      20101117                   //<          >
                    extern double MaximumRisk   = 0.1           ; //<          >
                    extern double Lots          = 0.1           ; //<          >
                    int       iBaseLag          = 20            ; //<          >
                    int       iBaseBar          = 1             ; //<          >
                    int       iBollPeriod       = 30            ; //<          >
                    int       iBollDevi         = 2             ; //<          >
                    int       iBollShift        = 0             ; //<          >  
                    double    dFactorTP         = 1.0           ; //<          >
                    double    dFactorSL         = 2.0           ; //<          >
                    int       iTradeBarOnce     = 1             ; //<          >
                    int       iSlippage         = 1             ; //<          >
                    double    dLots             = 1             ; //<          > 
                    int       iTradeBarTime     = EMPTY         ; //<          >
//-----------Defining Entry Strategy--------------------                    
                    int       iSignalOpen ()                      //<          >
{                                                                 //<          >
if    ( ( iTradeBarTime    == iTime   ( 0 , 0 , 0 ) )             //<          >
     && ( iTradeBarOnce    == 1 ) )     return    ( EMPTY     ) ; //<          > 
//                                                                //<          > 
static    int       iTime_0 = EMPTY                             ; //<          >  
if      (           iTime_0 < iTime   ( 0 , 0 , 0 ) )             //<          > 
        {           iTime_0 = iTime   ( 0 , 0 , 0 )             ; //<          >
          iTradeBarTime     = EMPTY                             ; //<          >
//------------------          
          static    double    dHighest , dLowest                ; //<          >
          dHighest = High   [ iHighest ( 0 , 0    , MODE_HIGH ,   //<          >
                              iBaseLag , iBaseBar           ) ] ; //<          >
          dLowest  = Low    [ iLowest  ( 0 , 0    , MODE_LOW  ,   //<          >
                              iBaseLag , iBaseBar           ) ] ; //<          >
                                                                  //<          >
          static double     dBollLow ,  dBollHigh               ; //<?????????          
                                                                  //<?????????                                                                  
          dBollLow    = iBands ( NULL     , 0 , iBollPeriod ,     //????????????
                            iBollDevi , 0 ,     PRICE_WEIGHTED ,  //????????????
                            MODE_LOWER    ,     iBollShift  )   ; //???????????? 
          dBollHigh   = iBands ( NULL     , 0 , iBollPeriod ,     //????????????
                            iBollDevi , 0 ,     PRICE_WEIGHTED ,  //????????????
                            MODE_UPPER   ,      iBollShift  )   ; //???????????? 
                                                                  //???????????? 
          static double BarHighPatterns ,  BarLowPatterns       ; //???????????? 
                                                                  //????????????
//-----------                                                                  
if ( Open[3] < dBollLow )                                         //????????????
 return (BarHighPatterns);                                        //????????????
                                                                     
else                                                              //????????????
 
if ( Open[3] > dBollHigh)                                         //????????????
 return (BarLowPatterns);                                         //????????????
                                                                    
          BarHighPatterns   =                                     //????????????
              ( Close[3] > dBollHigh  &&  Close[2] > Open[2]  &&  //????????????
                Close[1] > Open[1]                            ) ; //????????????
          BarLowPatterns    =                                     //????????????
              ( Close[3] < dBollLow  &&   Close[2] < Open[2]  &&  //????????????
                Close[1] > Open[1]                            ) ; //????????????    
                                                                  //<          >
        } // if                                                   //<          >
double    dAsk    = MarketInfo        ( Symbol () , MODE_ASK  ) ; //<          >
double    dBid    = MarketInfo        ( Symbol () , MODE_BID  ) ; //<          >
if      ( dAsk    > BarHighPatterns )   return    ( OP_BUY    ) ; //<          >
if      ( dBid    < BarLowPatterns  )   return    ( OP_SELL   ) ; //<          >
                                        return    ( EMPTY     ) ; //<          >       
} 
//--------------------------                                      //<          >
int       iTryOpen ()                                             //<          >
{                                                                 //<          >
int       iCommand          = iSignalOpen ()                    ; //<          >
if      ( iCommand         == EMPTY  )                return    ; //<          >
if      ( iCommand         == OP_BUY )                            //<          >
if      ( iCommand         == OP_SELL)                            //<          >????????????????????
        { string    sType   = "Buy"  ;  int  iColor = Blue    ; } //<          >? From
else    {           sType   = "Sell" ;       iColor = Red     ; } //<          >  Here
//                                                                //<          >   |
if      ( iCommand         == OP_BUY  ) int  iMode  = MODE_ASK  ; //<          >   |
else                                                              //<          >   |
if      ( iCommand         == OP_SELL )      iMode  = MODE_BID  ; //<          >? To Here
double    dPrice  = MarketInfo ( Symbol () , iMode            ) ; //<          >
//                                                                //<          >                                                //<          >lot =Lots
OrderSend  ( Symbol ()       , iCommand    ,  LotsOptimized() ,   //<          >
             NormalizeDouble ( dPrice , Digits )              ,   //<          >
             iSlippage  , 0  , 0 , "" , MAGIC    ,                //<          >
                0  , iColor  ) ;                                  //<          >
//                                                                //<          >
int       iTrap   = GetLastError ()                             ; //<          >
if      ( iTrap  == 0 )                                           //<          >
        { Alert   ( sType , " Was a Big Success"            ) ; } //<          >
else    { Alert   ( sType , " open exception "      , iTrap ) ; } //<          >
}                                                                 //<          >
//------------Defining Close Strategy---------------- 
int       iSignalClose ()                                         //<          >
{                                                                 //<          >
static    int       iTime_0 = EMPTY                             ; //<          >
if      (           iTime_0 < iTime   ( 0 , 0 , 0 ) )             //<          >
        {           iTime_0 = iTime   ( 0 , 0 , 0 )             ; //<          >
          static    double    dATR    , dProfit  , dLoss        ; //<          >
          dATR    = iATR    ( 0 , 0   , iBaseLag , iBaseBar   ) ; //<          >
        } // if                                                   //<          >
//                                                                //<          >
double    dDelta  = OrderOpenPrice () - OrderClosePrice ()      ; //<          >
//                                                                //<          >
if      ( OrderType ()     == OP_BUY  )                           //<          >
        { dProfit = -dDelta ; dLoss  =  dDelta                ; } //<          >
else if ( OrderType ()     == OP_SELL )                           //<          >
        { dProfit =  dDelta ; dLoss  = -dDelta                ; } //<          >
else                                    return    ( EMPTY     ) ; //<          >
//                                                                //<          >
if      ( dProfit > dATR * dFactorTP )  return    ( TRUE      ) ; //<          >
if      ( dLoss   > dATR * dFactorSL )  return    ( TRUE      ) ; //<          >
                                        return    ( EMPTY     ) ; //<          >
}
//-------------------
int       iTryClose ()                                            //<          >
{                                                                 //<          >
int       iCommand          = iSignalClose ()                   ; //<          >
if      ( iCommand         == EMPTY  )                return    ; //<          >
if      ( OrderType ()     == OP_BUY )                            //<          >
        { string    sType   = "Buy"  ;  int  iColor = Red     ; } //<          >
else    {           sType   = "Sell" ;       iColor = Blue    ; } //<          >
//                                                                //<          >
if      ( OrderProfit ()    > 0      )  string sAct = "Take"    ; //<          >
                                        else   sAct = "Stop"    ; //<          >
double    dPrice  = OrderClosePrice ()                          ; //<          >
//                                                                //<          >
OrderClose ( OrderTicket ()  , OrderLots ()                   ,   //<          >
             NormalizeDouble ( dPrice , Digits )              ,   //<          >
             iSlippage                              , iColor  ) ; //<          >
//                                                                //<          >
int       iTrap   = GetLastError ()                             ; //<          >
if      ( iTrap  == 0 ) { iTradeBarTime = iTime ( 0 , 0 , 0 ) ;   //<          >
          Alert   ( sType , " closed with Hard "    , sAct  ) ; } //<          >
else    { Alert   ( sType , " close exception "     , iTrap ) ; } //<          >
}                                                                 //<          >                                                                 //<          >
//---------
int       iGetTicket ()                                           //<          >
{                                                                 //<          >
for     ( int i   = OrdersTotal () - 1 ; i >= 0 ; i -- )          //<          >
        {                                                         //<          >
          if      ( OrderSelect ( i , SELECT_BY_POS ) == TRUE   ) //<          >
          if      ( OrderMagicNumber ()               == MAGIC)   //<          >
                                      return ( OrderTicket () ) ; //<          >
        } // for                                                  //<          >
                                      return ( EMPTY          ) ; //<          >
}                                                                 //<          >
//---------

//--------Calculating Optimize Lot Size--------------- 
double LotsOptimized()                                            //<          >
  {                                                               //<          > 
   double lot=Lots;                                               //<          > 
//---- select lot size                                            //<          > 
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/200.0,1);  //<          > 
                                                                  //<          > 
//---- return lot size                                            //<          > 
   if(lot<0.1) lot=0.1;                                           //<          > 
   return(lot);                                                   //<          > 
  }                                                               //<          > 
//---------
int       init    ()                                              //<          >
{                                                                 //<          >
Alert   ( ""               , "Start " , UninitializeReason () ) ; //<          >

}  
//-----------
int       deinit  ()                                              //<          >
{                                                                 //<          >
Alert   ( ""               , "Stop "  , UninitializeReason () ) ; //<          >
}                     
//-----
int       start   ()                                              //<          >
{                                                                 //<          >
//----
static    int       iTrigger   = 0       ; if ( iTrigger == 0 ) { //<          >
  if  ( ( iTime ( 0 , 0 , 0 ) == 0                          )     //<          >
  ||    ( iBars ( 0 , 0     )  < iBaseLag     + iBaseBar    ) )   //<          >
          return                         ; else iTrigger  = 1 ; } //<          >
//------
int       iTicket           = iGetTicket ()                     ; //<          >
//                                                                //<          >
if      ( iTicket < 0 )       iTryOpen   ()                     ; //<          >
else                          iTryClose  ()                     ; //<          >
//------
int       iTrap   =           GetLastError ()                   ; //<          >
if      ( iTrap   > 0 )       Alert  ( "Exception " , iTrap   ) ; //<          >  
}